
#include <stdafx.h>
#include "commctrl.h"


#include <stdio.h>




#include "os.h"
#include "wimp.h"
#include "flex.h"


#include "oserr.h"
#include "wos.h"
#include "poll.h"
#include "userdraw.h"
#include "osglue.h"
#include "ospoll.h"
#include "etc.h"
#include "alloc.h"


#include "deb.h"


#include "comctls.h"



os_error * cc_spinrange(wimp_w window,int icon,int min,int max)
{
 os_error * err;
 LRESULT    result;

 err=XSendDlgItemMessage((HWND)window,icon,UDM_SETRANGE32,(WPARAM)min,(LPARAM)max,&result);

 return(err);
}



/*************************************************************************************************/



typedef struct comboboxstr
{
 wimp_w             handle;
 int                id;
 cc_comboboxeventfn fn;
 int                userhandle;


} comboboxstr;




static comboboxstr combobox;


#define XBITMAP 16
#define YBITMAP 16




static os_error * comboboxdraw(MSG * msg,uservalue userhandle,int * ack,int * code,int * reverselogic)
{
 TCHAR            tchBuffer[512]; 
 TEXTMETRIC       tm;
 int              x;
 int              y; 
 LPDRAWITEMSTRUCT lpdis; 
 int              itype;
 char             itemtext[512];
 char           * p;
 HICON            hi; 
 comboboxstr    * cb;
 int              xshift;

//  cprintf("red");



 cb=(comboboxstr*)userhandle;
 if(cb->id==LOWORD(msg->wParam))
 {
  *ack=1;
  *code=0;

  lpdis=(LPDRAWITEMSTRUCT)msg->lParam; 

//      cprintf("red code %d %d",lpdis->itemAction,lpdis->itemState);

  // If there are no list box items, skip this message. 
 
 // if(lpdis->itemID==-1) return(NULL);

//  cprintf("red code %d %d",lpdis->itemAction,lpdis->itemState);

  switch(lpdis->itemAction) 
  { 
   case      ODA_FOCUS:  // lose/gain focus, check itemState
   case     ODA_SELECT:  // selection changed, check itemState
   case ODA_DRAWENTIRE:

                       x=lpdis->rcItem.left;
 
                       if(lpdis->itemState & ODS_COMBOBOXEDIT)
                       {
                        readicon((wimp_w)msg->hwnd,lpdis->CtlID,tchBuffer,sizeof(tchBuffer)/sizeof(TCHAR));
//                        cprintf("red %s",tchBuffer);
                       }
                       else
                       {
                        SendMessage(lpdis->hwndItem, CB_GETLBTEXT,lpdis->itemID,(LPARAM)tchBuffer); 
                       }

                       if (lpdis->itemState & ODS_SELECTED) 
                       { 
                        SetBkColor(lpdis->hDC,GetSysColor(COLOR_HIGHLIGHT));
                        SetTextColor(lpdis->hDC,GetSysColor(COLOR_HIGHLIGHTTEXT));
                        FillRect(lpdis->hDC, &lpdis->rcItem, (HBRUSH) (COLOR_HIGHLIGHT+1));
                       }
                       else
                       {
                        SetBkColor(lpdis->hDC,GetSysColor(COLOR_WINDOW));
                        SetTextColor(lpdis->hDC,GetSysColor(COLOR_MENUTEXT));
                        FillRect(lpdis->hDC, &lpdis->rcItem, (HBRUSH) (COLOR_WINDOW+1));
                       }

                       p=tchBuffer;
                       while(*p)
                       {
                        p=getitem(p,&itype,itemtext);

                        if(itype=='s')
                        {
                         GetTextMetrics(lpdis->hDC, &tm); 
 
                         y=(lpdis->rcItem.bottom+lpdis->rcItem.top-tm.tmHeight)/2; 
 
                         TextOut(lpdis->hDC,x,y,itemtext,strlen(itemtext));
                        }
                        else
                        if(itype=='l')
                        {
                         int idx;
                         HIMAGELIST hSysImgList;

                         x+=4;
                         sscanf(itemtext,"%d %d",&hSysImgList,&idx);
                         
                         y=(lpdis->rcItem.bottom+lpdis->rcItem.top-YBITMAP)/2;
                         idx=ImageList_Draw(hSysImgList,idx,lpdis->hDC,x,y,ILD_TRANSPARENT);
                         x+=4+XBITMAP;
                        }
                        else
                        if(itype=='i')
                        {
                         x+=4;
                         hi=(HICON)LoadImage(AppInstance,itemtext,IMAGE_ICON,XBITMAP,YBITMAP,LR_SHARED);
                         y=(lpdis->rcItem.bottom+lpdis->rcItem.top-YBITMAP)/2; 
                         DrawIconEx(lpdis->hDC,x,y,hi,XBITMAP,YBITMAP,0,0,DI_NORMAL);
                         x+=4+XBITMAP;
                        }
                        else
                        if(itype=='t')
                        {
                         if(sscanf(itemtext,"%d",&xshift)==1)
                         {
                          x+=xshift;
                         }
                        }
                       }
                      // Is the item selected? 
 
               /*        if(lpdis->itemState & ODS_FOCUS) 
                       { 
                        DrawFocusRect(lpdis->hDC, &lpdis->rcItem); 
                       }   */

                       break;
  }
 }
 
 return(NULL);

 USE(reverselogic);
}


static os_error * comboboxmeasure(MSG * msg,uservalue userhandle,int * ack,int * code,int * reverselogic)
{
 LPMEASUREITEMSTRUCT lpmis; 
// TEXTMETRIC tm; 

 return(NULL);

 *ack=1;
 *code=0;

// cprintf("cb measure");

 lpmis = (LPMEASUREITEMSTRUCT)msg->lParam; 
 
 // Set the height of the list box items. 

// GetTextMetrics(lpdis->hDC, &tm); 

 
 lpmis->itemHeight = 16; // GetSystemMetrics(SM_CYMENU); 
 
 return(NULL);

 USE(reverselogic);
 USE(userhandle);
}



static os_error * comboboxmess(MSG * msg,uservalue userhandle,int * ack,int * code,int * reverselogic)
{
 os_error        * err;
 comboboxstr     * cb;
 int               note;
 int               index;

 err=NULL;

// cprintf("combo mess");

 cb=(comboboxstr*)userhandle;
 if(cb->id==LOWORD(msg->wParam))
 {
  *ack=1;
  *code=0;

//  cprintf("combo x2");

  note=HIWORD(msg->wParam);
  if(note==CBN_SELENDOK)
  {
   if(cb->fn)
   {
    index=SendDlgItemMessage((HWND)cb->handle,cb->id,CB_GETCURSEL,0,0);
    err=cb->fn(CC_COMBOBOXSELECT,cb->handle,cb->userhandle,index,NULL);
   }
  }
 }

 return(err);

 USE(reverselogic);
}





os_error * cc_addcombobox(wimp_w handle,uservalue userhandle,int id,comboboxh * comboboxhandle,cc_comboboxeventfn fn)
{
 os_error    * err;
 comboboxstr * cb;

 err=salloc((flex_ptr)comboboxhandle,sizeof(comboboxstr));
 if(!err)
 {
  cb=(comboboxstr*)(*comboboxhandle);

  cb->handle=handle;
  cb->id=id;
  cb->userhandle=userhandle;
  cb->fn=fn;

  addwinmessage(comboboxmess,WM_COMMAND,handle,(uservalue)*comboboxhandle);
  addwinmessage(comboboxdraw,WM_DRAWITEM,handle,(uservalue)*comboboxhandle);
  addwinmessage(comboboxmeasure,WM_MEASUREITEM,handle,(uservalue)*comboboxhandle);

 // when the window is created this handler isn't attached so the height can't be set

// SendDlgItemMessage((HWND)handle,id,CB_SETITEMHEIGHT,0,16);
// SendDlgItemMessage((HWND)handle,id,CB_SETITEMHEIGHT,-1,16);
 }

 return(err);
}


os_error * cc_remcombobox(comboboxh comboboxhandle)
{
 comboboxstr * lp;

 lp=(comboboxstr*)comboboxhandle;
 if(lp)
 {
  remwinmessage(comboboxmess,WM_COMMAND,lp->handle,(uservalue)comboboxhandle);
  remwinmessage(comboboxdraw,WM_DRAWITEM,lp->handle,(uservalue)comboboxhandle);
  remwinmessage(comboboxmeasure,WM_MEASUREITEM,lp->handle,(uservalue)comboboxhandle);

  sfree((flex_ptr)&lp);
 }

 return(NULL);
}




os_error * cc_addcomboboxstring(comboboxh comboboxhandle,char * string)
{
 comboboxstr * lp;
 int           code;

 lp=(comboboxstr*)comboboxhandle;

 code=SendDlgItemMessage((HWND)lp->handle,lp->id,CB_ADDSTRING,0,(LPARAM)string);

 return(NULL);
}



os_error * cc_selectcombobox(comboboxh comboboxhandle,int index)
{
 comboboxstr * lp;
 int           code;

 lp=(comboboxstr*)comboboxhandle;

 code=SendDlgItemMessage((HWND)lp->handle,lp->id,CB_SETCURSEL,index,(LPARAM)0);

 return(NULL);
}


os_error * cc_getselectcombobox(comboboxh comboboxhandle,int * index)
{
 comboboxstr * lp;

 lp=(comboboxstr*)comboboxhandle;

 *index=SendDlgItemMessage((HWND)lp->handle,lp->id,CB_GETCURSEL,0,0);   

 return(NULL);
}





/*******************************************************************************/



typedef struct listboxstr
{
 wimp_w            handle;
 uservalue         userhandle;
 int               id;
 cc_listboxeventfn fn;


} listboxstr;




static os_error * listboxdraw(MSG * msg,uservalue userhandle,int * ack,int * code,int * reverselogic)
{
 TCHAR            tchBuffer[512]; 
 TEXTMETRIC       tm;
 int              x;
 int              y; 
 LPDRAWITEMSTRUCT lpdis; 
 int              itype;
 char             itemtext[512];
 char           * p;
 HICON            hi; 
 listboxstr     * lb;
 int              xshift;

 lb=(listboxstr*)userhandle;
 if(lb->id==LOWORD(msg->wParam))
 {
  *ack=1;
  *code=0;

  lpdis=(LPDRAWITEMSTRUCT)msg->lParam; 
 
  // If there are no list box items, skip this message. 
 
  if(lpdis->itemID==-1) return(NULL);

  switch(lpdis->itemAction) 
  { 
   case      ODA_FOCUS:  // lose/gain focus, check itemState
   case     ODA_SELECT:  // selection changed, check itemState
   case ODA_DRAWENTIRE:

                       x=lpdis->rcItem.left;
    
                       SendMessage(lpdis->hwndItem, LB_GETTEXT,lpdis->itemID,(LPARAM)tchBuffer); 

                       if (lpdis->itemState & ODS_SELECTED) 
                       { 
                        SetBkColor(lpdis->hDC,GetSysColor(COLOR_HIGHLIGHT));
                        SetTextColor(lpdis->hDC,GetSysColor(COLOR_HIGHLIGHTTEXT));
                        FillRect(lpdis->hDC, &lpdis->rcItem, (HBRUSH) (COLOR_HIGHLIGHT+1));
                       }
                       else
                       {
                        SetBkColor(lpdis->hDC,GetSysColor(COLOR_WINDOW));
                        SetTextColor(lpdis->hDC,GetSysColor(COLOR_MENUTEXT));
                        FillRect(lpdis->hDC, &lpdis->rcItem, (HBRUSH) (COLOR_WINDOW+1));
                       }

                       p=tchBuffer;
                       while(*p)
                       {
                        p=getitem(p,&itype,itemtext);

                        if(itype=='s')
                        {
                         GetTextMetrics(lpdis->hDC, &tm); 
 
                         y=(lpdis->rcItem.bottom+lpdis->rcItem.top-tm.tmHeight)/2; 
 
                         TextOut(lpdis->hDC,x,y,itemtext,strlen(itemtext));
                        }
                        else
                        if(itype=='i')
                        {
                         x+=4;
                         hi=(HICON)LoadImage(AppInstance,itemtext,IMAGE_ICON,XBITMAP,YBITMAP,LR_SHARED);
                         y=(lpdis->rcItem.bottom+lpdis->rcItem.top-YBITMAP)/2; 
                         DrawIconEx(lpdis->hDC,x,y,hi,XBITMAP,YBITMAP,0,0,DI_NORMAL);
                         x+=4+XBITMAP;
                        }
                        else
                        if(itype=='l')
                        {
                         int idx;
                         HIMAGELIST hSysImgList;

                         x+=4;
                         sscanf(itemtext,"%d %d",&hSysImgList,&idx);
                         
                         y=(lpdis->rcItem.bottom+lpdis->rcItem.top-YBITMAP)/2;
                         idx=ImageList_Draw(hSysImgList,idx,lpdis->hDC,x,y,ILD_TRANSPARENT);
                         x+=4+XBITMAP;
                        }
                        else
                        if(itype=='t')
                        {
                         if(sscanf(itemtext,"%d",&xshift)==1)
                         {
                          x+=xshift;
                         }
                        }
                       }

                       // Is the item selected? 
 
                       if(lpdis->itemState & ODS_FOCUS) 
                       { 
                        DrawFocusRect(lpdis->hDC, &lpdis->rcItem); 
                       } 

                       break;
  }
 }

 return(NULL);

 USE(reverselogic);
}



static os_error * listboxmeasure(MSG * msg,uservalue userhandle,int * ack,int * code,int * reverselogic)
{
 LPMEASUREITEMSTRUCT lpmis; 
// TEXTMETRIC tm; 

 *ack=1;
 *code=0;

// cprintf("lb measure");

 lpmis = (LPMEASUREITEMSTRUCT)msg->lParam; 
 
 // Set the height of the list box items. 

// GetTextMetrics(lpdis->hDC, &tm); 

 
 lpmis->itemHeight = 16; // GetSystemMetrics(SM_CYMENU); 
 
 return(NULL);

 USE(reverselogic);
 USE(userhandle);
}





static os_error * listboxmess(MSG * msg,uservalue userhandle,int * ack,int * code,int * reverselogic)
{
 os_error       * err;
 listboxstr     * lb;
 int              note;
 int              index;

 err=NULL;

 lb=(listboxstr*)userhandle;
 if(lb->id==LOWORD(msg->wParam))
 {
  *ack=1;
  *code=0;

  if(lb->fn)
  {
   note=HIWORD(msg->wParam);
   if(note==LBN_DBLCLK)
   {
    index=SendDlgItemMessage((HWND)lb->handle,lb->id,LB_GETCARETINDEX,0,0);
    err=lb->fn(CC_LISTBOXDBLE,lb->handle,lb->userhandle,index,NULL);
   }
   else
   if(note==LBN_SELCHANGE)
   {
    index=SendDlgItemMessage((HWND)lb->handle,lb->id,LB_GETCURSEL,0,0);   
    err=lb->fn(CC_LISTBOXSELCHANGE,lb->handle,lb->userhandle,index,NULL);
   }
  }
 }

 return(err);

 USE(reverselogic);
}




os_error * cc_addlistbox(wimp_w handle,uservalue userhandle,int id,listboxh * listboxhandle,cc_listboxeventfn fn)
{
 os_error   * err;
 listboxstr * lb;

 err=salloc((flex_ptr)listboxhandle,sizeof(listboxstr));
 if(!err)
 {
  lb=(listboxstr*)(*listboxhandle);

  lb->handle=handle;
  lb->userhandle=userhandle;
  lb->id=id;
  lb->fn=fn;

  addwinmessage(listboxmess,WM_COMMAND,handle,(uservalue)*listboxhandle);
  addwinmessage(listboxdraw,WM_DRAWITEM,handle,(uservalue)*listboxhandle);
  addwinmessage(listboxmeasure,WM_MEASUREITEM,handle,(uservalue)*listboxhandle);

  SendDlgItemMessage((HWND)handle,id,LB_SETITEMHEIGHT,0,16);
 }

 return(err);
}


os_error * cc_remlistbox(listboxh listboxhandle)
{
 listboxstr * lp;

 lp=(listboxstr*)listboxhandle;
 if(lp)
 {
  remwinmessage(listboxmess,WM_COMMAND,lp->handle,(uservalue)listboxhandle);
  remwinmessage(listboxdraw,WM_DRAWITEM,lp->handle,(uservalue)listboxhandle);
  remwinmessage(listboxmeasure,WM_MEASUREITEM,lp->handle,(uservalue)listboxhandle);

  sfree((flex_ptr)&lp);
 }

 return(NULL);
}




os_error * cc_addlistboxstring(listboxh listboxhandle,char * string)
{
 listboxstr * lp;

 lp=(listboxstr*)listboxhandle;

 SendDlgItemMessage((HWND)lp->handle,lp->id,LB_ADDSTRING,0,(LPARAM)string);


 return(NULL);
}


os_error * cc_clearlistbox(listboxh listboxhandle)
{
 listboxstr * lp;

 lp=(listboxstr*)listboxhandle;

 SendDlgItemMessage((HWND)lp->handle,lp->id,LB_RESETCONTENT,0,0);

 return(NULL);
}



os_error * cc_getlistboxstring(listboxh listboxhandle,int index,char * buffer,int maxlen)
{
 listboxstr * lp;

 lp=(listboxstr*)listboxhandle;

 SendDlgItemMessage((HWND)lp->handle,lp->id,LB_GETTEXT,index,(LPARAM)buffer);

 return(NULL);

 USE(maxlen);
}


os_error * cc_selectlistbox(listboxh listboxhandle,int index)
{
 listboxstr * lp;

 lp=(listboxstr*)listboxhandle;

 SendDlgItemMessage((HWND)lp->handle,lp->id,LB_SETCURSEL,index,(LPARAM)0);

 return(NULL);
}



os_error * cc_getselectlistbox(listboxh listboxhandle,int * index)
{
 listboxstr * lb;

 lb=(listboxstr*)listboxhandle;

 *index=SendDlgItemMessage((HWND)lb->handle,lb->id,LB_GETCURSEL,0,0);   

 return(NULL);
}


/***************************************************************************************/


typedef struct treestr
{
 wimp_w            handle;
 uservalue         userhandle;
 int               id;
 cc_treeeventfn    fn;


} treestr;





os_error * cc_addtree(wimp_w handle,uservalue userhandle,int id,int * treehandle,cc_treeeventfn fn)
{
 os_error   * err;
 treestr    * tree;

 err=salloc((flex_ptr)treehandle,sizeof(treestr));
 if(!err)
 {
  tree=(treestr*)(*treehandle);

  tree->handle=handle;
  tree->userhandle=userhandle;
  tree->id=id;
  tree->fn=fn;

//  addwinmessage(listboxmess,WM_COMMAND,handle,*listboxhandle);
//  addwinmessage(listboxdraw,WM_DRAWITEM,handle,*listboxhandle);
//  addwinmessage(listboxmeasure,WM_MEASUREITEM,handle,*listboxhandle);

//  SendDlgItemMessage((HWND)handle,id,LB_SETITEMHEIGHT,0,16);
 }

 return(err);
}


os_error * cc_remtree(int treehandle)
{
 treestr * treep;

 treep=(treestr*)treehandle;
 if(treep)
 {
//  remwinmessage(listboxmess,WM_COMMAND,lp->handle,listboxhandle);
//  remwinmessage(listboxdraw,WM_DRAWITEM,lp->handle,listboxhandle);
//  remwinmessage(listboxmeasure,WM_MEASUREITEM,lp->handle,listboxhandle);

  sfree((flex_ptr)&treep);
 }

 return(NULL);
}



os_error * cc_addtreeitem(wimp_w treehandle,int parent,int after,char * text,int mask,int childn,int id,int * handle)
{
 TVINSERTSTRUCT   insert;
 treestr        * treep;

 treep=(treestr*)treehandle;
 if(treep)
 {
  memset(&insert,0,sizeof(TVINSERTSTRUCT));

  insert.hParent=(HTREEITEM)parent;
  insert.hInsertAfter=(HTREEITEM)after;
  insert.item.pszText=text;
  insert.item.cchTextMax=strlen(text)+1;
  insert.item.mask=mask;
  insert.item.lParam=id;
  insert.item.cChildren=childn;

  *handle=SendDlgItemMessage((HWND)treep->handle,treep->id,TVM_INSERTITEM,0,(LPARAM)&insert);


 }

 return(NULL);
}


