
#include <stdafx.h>
#include <stdio.h>
#include <stdlib.h>

#include "Htmlhelp.h" 


#include "os.h"

#include "fsx.h"
#include "oserr.h"
#include "deb.h"
#include "wimp.h"
#include "werr.h"
#include "colour.h"
#include "wos.h"
#include "poll.h"
#include "bits.h"
#include "hourglass.h"
#include "etc.h"

#include "oshelp.h"


/*

 HWND HtmlHelp(HWND hwndCaller,LPCSTR pszFile,UINT uCommand,DWORD dwData);




*/



static int helpentered;

static os_error * helpmouse(wimp_w handle,uservalue userhandle,wimp_w eventhandle,LPARAM lp,WPARAM wParam,int * ack)
{
 mousestr mouse;

 cprintf("help mouse");


	if(wParam==WM_NCLBUTTONDBLCLK ||
    wParam==WM_NCLBUTTONDOWN ||
//    wParam==WM_NCLBUTTONUP ||
//    wParam==WM_NCRBUTTONDBLCLK ||
    wParam==WM_NCRBUTTONDOWN ||
//    wParam==WM_NCRBUTTONUP ||
//				wParam==WM_LBUTTONDBLCLK ||
    wParam==WM_LBUTTONDOWN ||
//    wParam==WM_LBUTTONUP ||
//  		wParam==WM_RBUTTONDBLCLK ||
    wParam==WM_RBUTTONDOWN //||
//    wParam==WM_RBUTTONUP
   )
 {
  remmouseevent(helpmouse,handle,userhandle);

  getpointer(&mouse);

  helpicon(mouse.handle,mouse.icon,eventhandle);

  cprintf("help mouse event");

  hourglassoff();
  hourglassmode(0);
  helpentered=0;
  *ack=1;
 }

 return(NULL);

	USE(lp);
}




os_error * helpwhatsthis(wimp_w window)
{

 if(!helpentered)
 {
  addmouseevent(helpmouse,window,0);
  hourglassmode(1);
  hourglasson();
  helpentered=1;
 }

 return(NULL);
}




os_error * helppointer(wimp_w window)
{

 SendMessage((HWND)window,WM_SYSCOMMAND,SC_CONTEXTHELP,0);

 return(NULL);
}


os_error * helptopic(wimp_w window,char * topic)
{
 os_error * err;
 char       temp[MAX_PATH];

 err=fs_expandpath(topic,temp,sizeof(temp)/sizeof(TCHAR));
 if(!err)
 {
  cprintf("topic %s",topic);
  cprintf("temp %s",temp);

  HtmlHelp((HWND)window,temp,HH_DISPLAY_TOPIC,0);
 }

 return(err);
}



os_error * helppopup(wimp_w window,char * text,int x,int y)
{
 HH_POPUP popup;
 os_error * err;
 LOGFONT    lfont;
 int        osize;
 HFONT      handle;
 char       buffer[256];
 char       string[1024];
 char     * temp;
 int        len;

 memset(&popup,0,sizeof(popup));
 popup.cbStruct=sizeof(HH_POPUP);

 popup.pt.x=x;
 popup.pt.y=y;
 popup.clrForeground=(COLORREF)-1;
 popup.clrBackground=(COLORREF)-1;
 popup.rcMargins.top=-1;
 popup.rcMargins.left=-1;
 popup.rcMargins.right=-1;
 popup.rcMargins.bottom=-1;
//  popup.pszFont="Arial, 10, ,";
 popup.pszFont=buffer;

 len=strlen(text)+1;
 if(len<sizeof(string))
 {
  popup.pszText=string;
  temp=NULL;
 }
 else
 {
  temp=(char*)malloc(len);
  popup.pszText=temp;
 }

 gstrans((char*)popup.pszText,NITEM(buffer),text,NULL);
// strcpy((char*)popup.pszText,text);

 handle=(HFONT)GetWindowLongPtr((HWND)window,DWLP_USER);
 err=XGetObject(handle,sizeof(LOGFONT),&lfont,&osize);

 xsprintf(sizeof(buffer)/sizeof(TCHAR),NULL,buffer,"%s, %d, ,",lfont.lfFaceName,-(lfont.lfHeight*72-cvdu.ydpi/2)/cvdu.ydpi);

// cprintf("help buffer %s",buffer);

 cprintf("help pop %s",popup.pszText);

// messagebox((char*)popup.pszText);

 HtmlHelp((HWND)window,NULL,HH_DISPLAY_TEXT_POPUP,(DWORD_PTR)&popup);

 if(temp) free(temp);

 return(NULL);
}

