/*->c.hourglass */

#include <stdafx.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>


#include "os.h"
#include "wimp.h"
#include "werr.h"

#include "deb.h"
#include "etc.h"

#include "wos.h"


#include "hourglass.h"


/*****************************************************************************/
                               /* Hourglass code */


static HCURSOR hchour;
static HCURSOR hcarrow;
static HCURSOR hchelp;

//static HCURSOR oldcursor;

static int     hourglassstate;

static int     xhourglassmode;

// tried various things here, reading the current cursor and then writing
// is open to the problem of the cursor having moved or being not what
// you expect when you read it - problem of hourglass when OP starts
// Plan B is to send the program a setcursor message



void hourglasspc(int percent)
{
 USE(percent);
}


void hourglasssmash(void)
{
 hourglassstate=0;
}


void hourglassoff(void)
{
 cprintf("hourglass-- %d",hourglassstate);
 if(hourglassstate>0) hourglassstate--;
 if(hourglassstate==0) SetCursor(hcarrow);
}



void hourglasson(void)
{
 cprintf("hourglass++ %d",hourglassstate);
// if(hourglassstate==0) oldcursor=GetCursor();
 hourglassstate++;
 if(xhourglassmode) SetCursor(hchelp);
 else               SetCursor(hchour);

 cprintf("hchour %x",hchour);
}



int hourglassmode(int mode)
{
 int temp;

 temp=xhourglassmode;
 xhourglassmode=mode;

 return(temp);
}



void hourglassonafter(int delay)
{
 USE(delay);
}




os_error * hourglassinit(void)
{

 cprintf("##### hourglass init #####");

 hchour=LoadCursor(NULL,IDC_WAIT); 
 hcarrow=LoadCursor(NULL,IDC_ARROW);
 hchelp=LoadCursor(NULL,IDC_HELP);

 return(NULL);
}


os_error * hourglasssetcursor(int * code)
{
 if(hourglassstate)
 {
  cprintf("forcing hour");
  
  *code=1;
  if(xhourglassmode) SetCursor(hchelp);
  else               SetCursor(hchour);
 }
 else
 {
  *code=0;
 }

 return(NULL);
}
