#include <stdafx.h>
#include "commctrl.h"



#include <stdlib.h>
#include <stdio.h>



#include "os.h"


#include "etc.h"
#include "wimp.h"
#include "transform.h"
#include "xprocess.h"
#include "sprite.h"
#include "wimp.h"


#include "sp.h"
#include "colour.h"
#include "osglue.h"
#include "oserr.h"
#include "osgraphics.h"
#include "ossprite.h"
#include "trans.h"
#include "wos.h"
#include "bits.h"


#include "deb.h"
#include "abx.h"

#include "userdraw.h"





#define XBITMAP 16
#define YBITMAP 16


#define XBITMAP32 32
#define YBITMAP32 32



// we don't handle quoting of double quotes in user redraw code
// so don't quote double quotes in this version

char * unquoteicontext(char * output,char * input,int maxsize)
{
 char * r;
 char * w;
 char * lt;

 r=input;
 w=output;
 lt=output+maxsize-1;

 while(*r)
 {
  if(*r=='\\')
  {
   *w++='\\';
   if(w>=lt) break;
  }
  *w++=*r++;
  if(w>=lt) break;
 }

 *w=0;

 return(output);
}





char * getitem(char * p,int * itype,char * itemtext)
{
 char * q;

 q=itemtext;

 if(*p=='\\')
 {
  p++;
  *itype=*p;
  p++;
 }
 else
 {
  *itype='s';
 }

 while(*p)
 {
  if(*p=='\\')
  {
   p++;
   if(*p=='\\') *q++=*p++;
   else
   {
    p--;
    break;
   }
  }
  else
  {
   *q++=*p++;
  }
 }

 *q=0;

 return(p);
}





char * getgivenitem(char * p,int itype,char * itemtext)
{
 char * q;
 int    ctype=0;

 q=itemtext;

 while(*p)
 {
  if(*p=='\\')
  {
   p++;
   ctype=*p++;
  }
  else
  {
   ctype='s';
  }

  if(itype==ctype)
  {
   while(*p)
   {
    if(*p=='\\')
    {
     p++;
     if(*p=='\\') *q++=*p++;
     else
     {
      p--;
      break;
     }
    }
    else
    {
     *q++=*p++;
    }
   }
   *q=0;
   break;
  }

  while(*p)
  {
   if(*p=='\\')    // double \ for escape
   {
    p++;
    if(*p=='\\') p++;
    else
    {
     p--;
     break;
    }
   }
   else
   {
    p++;
   }
  } 
 } 

 return(itype==ctype?itemtext:NULL);
}


// s ends up pointing at slash before token


int getitempointers(int itype,char * p,char ** s,char ** e,char ** ex)
{
 int    ctype=0;


 while(*p)
 {
  if(*p=='\\')
  {
   p++;
   ctype=*p++;
  }
  else
  {
   ctype='s';
  }

  if(itype==ctype)
  {
   if(s) *s=(p-2);
   
   while(*p)
   {
    if(*p=='\\')   // double \ for escape
    {
     p++;
     if(*p=='\\') p++;
     else
     {
      p--;
      if(e) *e=p;
      break;
     }
    }
    else
    {
     p++;
    }
   }

   if(!*p)
   {
    if(e) *e=p;
   }
   break;
  }

  while(*p)
  {
   if(*p=='\\')
   {
    p++;
    if(*p=='\\') p++;
    else
    {
     p--;
     break;
    }
   }
   else
   {
    p++;
   }
  } 
 } 


 if(ex)
 {
  while(*p++);
  *ex=(p-1);
 }

 return(itype==ctype);
}



void abxslice(int ctype,char * newparam,char * buffer)
{
 char * s;
 char * e;
 char * ex;
 int    shift;

 if(getitempointers(ctype,buffer,&s,&e,&ex))
 {
  shift=strlen(newparam)-((e-s)-2);

  memmove(e+shift,e,ex-e+1);
  XMEMCPYX(s+2,newparam,strlen(newparam));
 }
}








          
// believe this is not used, it should use drawabx2() code anyway

int drawitem(HWND hwnd,UINT icon,LPDRAWITEMSTRUCT lpdis)
{


#ifdef NEVER

 TCHAR            tchBuffer[1024]; 
 TEXTMETRIC       tm;
 int              x;
 int              y; 
 int              itype;
 char             itemtext[1024];
 char           * p;
 HICON            hi; 
 int              xshift;
 sprite_header  * sph;

 USE(icon);
 USE(hwnd);

 if(lpdis->CtlType==ODT_BUTTON)
 {

#ifdef NEVER  
  switch(lpdis->itemAction) 
  { 
   case      ODA_FOCUS:  // lose/gain focus, check itemState
   case     ODA_SELECT:  // selection changed, check itemState
   case ODA_DRAWENTIRE:
#endif

  x=lpdis->rcItem.left;
  
  SendMessage(lpdis->hwndItem,WM_GETTEXT,sizeof(tchBuffer),(LPARAM)tchBuffer); 

//  cprintf("dr %s state=%x",tchBuffer,lpdis->itemState);

  SetBkColor(lpdis->hDC,GetSysColor(COLOR_BTNFACE));
  SetTextColor(lpdis->hDC,GetSysColor(COLOR_MENUTEXT));
  FillRect(lpdis->hDC,&lpdis->rcItem,GetSysColorBrush(COLOR_BTNFACE));

  // use ODS_SELECTED for pushed

  p=tchBuffer;
  while(*p)
  {
   p=getitem(p,&itype,itemtext);

   if(itype=='s')
   {
    GetTextMetrics(lpdis->hDC,&tm); 
 
    y=(lpdis->rcItem.bottom+lpdis->rcItem.top-tm.tmHeight)/2; 
    TextOut(lpdis->hDC,x,y,itemtext,strlen(itemtext));
   }
   if(itype=='i')
   {
    x+=4;
    hi=(HICON)LoadImage(AppInstance,itemtext,IMAGE_ICON,XBITMAP,YBITMAP,LR_SHARED);
    y=(lpdis->rcItem.bottom+lpdis->rcItem.top-YBITMAP)/2; 
    DrawIconEx(lpdis->hDC,x,y,hi,XBITMAP,YBITMAP,0,0,DI_NORMAL);
    x+=4+XBITMAP;
   }
   else
   if(itype=='l')
   {
    int idx;
    HIMAGELIST hSysImgList;
    x+=4;
    sscanf(itemtext,"%d %d",&hSysImgList,&idx);
                         
    y=(lpdis->rcItem.bottom+lpdis->rcItem.top-YBITMAP)/2;
    idx=ImageList_Draw(hSysImgList,idx,lpdis->hDC,x,y,ILD_TRANSPARENT);
    x+=4+XBITMAP;
   }
   else
   if(itype=='t')
   {
    if(sscanf(itemtext,"%d",&xshift)==1)
    {
     x+=xshift;
    }
   }
   if(itype=='S')
   {
    y=(lpdis->rcItem.bottom+lpdis->rcItem.top-YBITMAP)/2;
    x+=4;
    sph=sprite_find((sprite_area*)sprites,itemtext);
    if(sph) sprite_render(sph,lpdis->hDC,x,y);
   }
  }

  // Is the item selected? 
  if(lpdis->itemState & ODS_FOCUS) 
  { 
   DrawFocusRect(lpdis->hDC, &lpdis->rcItem); 
  } 

  return(1);
 }


#endif

 return(0);
}




/*

  \s<string>                                              Text string
  \i<icon name>                                           Icon
  \l<image list handle><space><image list index>          Imagelist item
  \t<N pixels>                                            Tab
  \a<sprite name>                                         Sprite
  \b<border definition>
  \c<cursor name>                                         Cursor name

  \g<foreground colour>
  \k<background colour>

  \E<edge type>


  \L                                                      left
  \R                                                      right
  \C                                                      centre
  \T                                                      top
  \B                                                      bottom
  \V                                                      middle

  \u<0|1>                                                 underline


  \O<string>
                                                          S - selected
                                                          P - pushed
                                                          M - mouse over
                                                          F - focus
                                                          1 - true
                                                          0 - false

                                                          split by 
 
                                                          +   logical OR
                                                          -   logical AND

                                                          prefixed by

                                                          !   logical NOT


  \P<i|a|s><pointer>                                      set pointer
                                                          i==icon     + name
                                                          a==sprite   + name
                                                          s==system   + number


  \R                                                      radio

  \K                                                      type of click
                                                          1 one click
                                                          2 double click
                                                          A auto repeat
                                                          D drag
                                                          R release

  \N                                                      needs help


*/

// DrawEdge  - fancy borders
// DrawState - ampersand escaped text
// or DrawText


#define DBLEFT   0x0
#define DBRIGHT  0x1
#define DBCENTRE 0x2

#define DBTOP    0x0
#define DBBOTTOM 0x1
#define DBVERT   0x2





COLORREF getoscolour(int col)
{
 int colcode;

 colcode=(col & CCMASK);
 if(colcode!=CCNULL)
 {
  if(colcode==CCRGB)
  {
   return(COLREFFROMPAL(col));
  }
  else
  if(colcode<CCSYSBASE)  // 1 to 17 wimp colour
  {
   return(COLREFFROMPAL(cvdu.vdupal.c[colcode-CCWIMPBASE].word));
  }
  else
  if(colcode<CCTRANSPARENT)  // 18 to 18+MAXSYSCOLOUR-1 windows system colours
  {
   return(GetSysColor(winsyscolour[colcode-18]));
  }
  else                    // 255 transparent
  {
   return(0xFF000000);
  }
 }

 return(0xFF000000);
}






int drawabx2(char * buffer,HDC hdc,HFONT hfont,RECT * rect,int flags,sprite_area * spa)
{
 int              x;
 int              y; 
 int              itype;
 char             itemtext[1024];
 char           * p;
 HICON            hi; 
 int              xshift;
 newsprite_header  * sph;
 int              idx;
 HIMAGELIST       hSysImgList;
 int              hjust;
 int              vjust;
 int              fmode;
 SIZE             size;
 int              dy;
 int              dx;
 int              xpix;
 int              ypix;
 LOGFONT          lfont;
 HFONT            ulfont;
 int              renderstate;
 unsigned int     preva;
 int              prevb;
 HGDIOBJ          prevo;
 COLORREF         prevc;
 int              osize;
 int              slen;
 char           * s;
 int              c;
 int              command;
 int              negate;
 int              greyseen;
 COLORREF         cfref;
 COLORREF         cbref;
 HFONT            oldfont;
 HPEN             oldpen;
 HPEN             basepen;
 HPEN             currentpen;

 x=rect->left;
 y=rect->top;

 vjust=DBTOP;
 hjust=DBLEFT;
 ulfont=NULL;
 currentpen=NULL;
 basepen=NULL;
  

 XSetBkColor(hdc,cbref=GetSysColor(COLOR_BTNFACE),&prevc);
 XSetTextColor(hdc,cfref=GetSysColor(COLOR_MENUTEXT),&prevc);

 oldfont=(HFONT)SelectObject(hdc,(HFONT)hfont);



// FillRect(hdc,rect,GetSysColorBrush(COLOR_BTNFACE));

// cprintf("drawabx2");
// cprintf("drawabx2 %s",buffer);

 greyseen=0;
 renderstate=1;

 p=buffer;
 while(*p)
 {
  p=getitem(p,&itype,itemtext);

  switch(itype)
  {
    case 'E':
													if(renderstate)
													{
              xshift=getint(itemtext,NULL);
              if(xshift==0) xshift=EDGE_BUMP;
              else
              if(xshift==1) xshift=EDGE_ETCHED;
              else
              if(xshift==2) xshift=EDGE_RAISED;
              else
              if(xshift==3) xshift=EDGE_SUNKEN;
              else
              {
               if(xshift==4)
               {
                oldpen=currentpen;
                currentpen=CreatePen(PS_SOLID,0,cfref);
                if(oldpen)
                {
                 SelectObject(hdc,currentpen);
                 DeleteObject(oldpen);
                }
                else
                {
                 basepen=(HPEN)SelectObject(hdc,currentpen);
                }

                MoveToEx(hdc,rect->left,rect->top,NULL);
                LineTo(hdc,rect->right-1,rect->top);
                LineTo(hdc,rect->right-1,rect->bottom-1);
                LineTo(hdc,rect->left,rect->bottom-1);
                LineTo(hdc,rect->left,rect->top);
               }
               break;
              }

              DrawEdge(hdc,rect,xshift,BF_RECT|BF_ADJUST);

              if(x<rect->left)  x=rect->left;
              if(x>rect->right) x=rect->right;
              if(y<rect->top)   y=rect->top;
              if(y>rect->bottom)y=rect->bottom;
													}
             break;

  case 'u':
             xshift=getint(itemtext,NULL);
             {
              if(xshift)
              {
               if(ulfont==NULL)
               {
                XGetObject(hfont,sizeof(LOGFONT),&lfont,&osize);
                lfont.lfUnderline=1;
                XCreateFontIndirect(&lfont,&ulfont);
               }
               XSelectObject(hdc,(HFONT)ulfont,&prevo);
              }
              else
              {
               XSelectObject(hdc,(HFONT)hfont,&prevo);
              }
             }
             break;
 
  case 'g':
             xshift=getint(itemtext,NULL);
//             cprintf("cref=%x xs=%x",cref,xshift);
             cfref=getoscolour(xshift);
             if((cfref & 0xFF000000)==0) XSetTextColor(hdc,cfref,&prevc);
             break;

  case 'k':
             xshift=getint(itemtext,NULL);
             cbref=getoscolour(xshift);
             if((cbref & 0xFF000000)==0) XSetBkColor(hdc,cbref,&prevc);
             break;

  
  case 's':
             if(renderstate)
             {
//														  cprintf("cref=%x",cfref);
              trans(itemtext,sizeof(itemtext));

//              cprintf("itemtext %s",itemtext);

              XGetTextExtentPoint32(hdc,itemtext,strlen(itemtext),&size);
              dx=dy=0;

              if(vjust==DBTOP)    fmode=TA_TOP;
              else
              if(vjust==DBBOTTOM) fmode=TA_BOTTOM;
              else
              {
               fmode=TA_TOP;         
               dy=((rect->bottom-rect->top)-size.cy)/2;
               dy-=y-rect->top;
              }

              if(hjust==DBLEFT)   fmode|=TA_LEFT;
              else
              if(hjust==DBRIGHT)  fmode|=TA_RIGHT;
              else                fmode|=TA_CENTER;

              XSetTextAlign(hdc,fmode,&preva);
              XSetBkMode(hdc,TRANSPARENT,&prevb);

//              XTextOut(hdc,x,y+dy,itemtext,strlen(itemtext));

              if((flags & USDGREYED) && !greyseen)
              {
               XSetTextColor(hdc,cfref=GetSysColor(COLOR_3DHILIGHT),&prevc);
               ExtTextOut(hdc,x+1,y+dy+1,ETO_CLIPPED,rect,itemtext,strlen(itemtext),NULL);
               XSetTextColor(hdc,cfref=GetSysColor(COLOR_GRAYTEXT),&prevc);
               ExtTextOut(hdc,x,y+dy,ETO_CLIPPED,rect,itemtext,strlen(itemtext),NULL);              
              }
              else
              {
               ExtTextOut(hdc,x,y+dy,ETO_CLIPPED,rect,itemtext,strlen(itemtext),NULL);
              }
             }
             break;


             hi=(HICON)LoadImage(AppInstance,itemtext,IMAGE_ICON,XBITMAP,YBITMAP,LR_SHARED);
             y=(rect->bottom+rect->top-YBITMAP)/2; 
             DrawIconEx(hdc,x,y,hi,XBITMAP,YBITMAP,0,0,DI_NORMAL);
             break;

    case 'i':
    case 'I':
             if(itype=='i') {xpix=XBITMAP;ypix=YBITMAP;}
             else           {xpix=XBITMAP32;ypix=YBITMAP32;}

             hi=(HICON)LoadImage(AppInstance,itemtext,IMAGE_ICON,xpix,ypix,LR_SHARED);

             if(hjust==DBRIGHT)  dx=-xpix;
             else
             if(hjust==DBCENTRE) dx=-(xpix/2);
             else                dx=0;

             if(vjust==DBTOP)    dy=0;
             else
             if(vjust==DBBOTTOM) dy=-ypix;
             else
             /*if(vjust==DBVERT)*/ dy=-(ypix/2);
             
//             y=(rect->bottom+rect->top-YBITMAP32)/2; 
             DrawIconEx(hdc,x+dx,y+dy,hi,xpix,ypix,0,0,DI_NORMAL);

             if(hjust==DBRIGHT)  x-=xpix;
             else
             if(hjust==DBLEFT)   x+=xpix;

             break;

    
    case 'l':
             hSysImgList=(HIMAGELIST)getint(itemtext,&slen);
             idx=getint(itemtext+slen+1,&slen);
             y=(rect->bottom+rect->top-YBITMAP)/2;
             idx=ImageList_Draw(hSysImgList,idx,hdc,x,y,ILD_TRANSPARENT);
             break;

    case 't':
             xshift=getint(itemtext,NULL);
             x+=xshift;
             break;

    case 'a':
             if(renderstate)
             {
              sph=sprite_find(spa,itemtext);
//            cprintf("a find %s %x",itemtext,sph);
              if(sph)
              {
               getspritesize((newsprite_header*)sph,&xpix,&ypix,NULL);
               if(hjust==DBRIGHT)  dx=-xpix;
               else
               if(hjust==DBCENTRE) dx=-(xpix/2);
               else                dx=0;

               if(vjust==DBTOP)    dy=0;
               else
               if(vjust==DBBOTTOM) dy=-ypix;
               else
               /*if(vjust==DBVERT)*/ dy=-(ypix/2);

               sprite_render2(sph,hdc,x+dx,y+dy,(flags & USDGREYED) && !greyseen);
              
               if(hjust==DBRIGHT)  x-=xpix;
               else
               if(hjust==DBLEFT)   x+=xpix;
              }
             }
             break;
 
    case 'L':
             hjust=DBLEFT;
             x=rect->left;
             break;

    case 'R':
             hjust=DBRIGHT;
             x=rect->right;
             break;

    case 'C':
             hjust=DBCENTRE;
             x=(rect->left+rect->right)/2;
             break;

    case 'T':
             vjust=DBTOP;
             y=rect->top;
             break;

    case 'B':
             vjust=DBBOTTOM;
             y=rect->bottom;
             break;

    case 'V':
             vjust=DBVERT;
             y=(rect->top+rect->bottom)/2;
             break;

/*

  O then string of 

  S - selected
  P - pushed
  M - mouse over
  F - focus
  G - grey
  1
  0

  split by 

  +   logical OR
  -   logical AND

  prefixed by

  !   logical NOT

 */

    case 'O':
             s=itemtext;
             command=negate=xshift=greyseen=0;

             while((c=*s++)!=0)
             {
              if(c=='!')
              {
               negate=1;
               continue;
              }

              if(c=='+' || c=='-')
              {
               command=c;
               continue;
              }

              if(c=='S') xshift=((flags & USDSELECTED)!=0);
              else
              if(c=='P') xshift=((flags & USDPUSHED)!=0);
              else
              if(c=='M') xshift=((flags & USDMOUSE)!=0);
              else
              if(c=='F') xshift=((flags & USDFOCUS)!=0);
              else
              if(c=='G')
              {
               xshift=((flags & USDGREYED)!=0);
               greyseen=1;
              }
              else
              if(c=='1') xshift=1;
              else
              if(c=='0') xshift=0;

              if(negate) xshift=!xshift;

              if(command=='-') renderstate=renderstate && xshift;
              else
              if(command=='+') renderstate=renderstate || xshift;
              else             renderstate=xshift;

              command=negate=0;
             }
             break;
    
  }
 }

 
 // has focus? 
 if(flags & USDFOCUS) 
 { 
  DrawFocusRect(hdc,rect); 
 }

 SelectObject(hdc,(HFONT)oldfont);

 if(ulfont)
 {
  XDeleteObject(ulfont);
 }


 if(basepen)
 {
  SelectObject(hdc,basepen);
 }

 if(currentpen)
 {
  DeleteObject(currentpen);
 }


 return(1);
}



int drawabx(HWND hwnd,HDC hdc,HFONT hfont,RECT * rect,int flags,sprite_area * spa)
{
 TCHAR            buffer[256];

// SendMessage(hwnd,WM_GETTEXT,sizeof(buffer),(LPARAM)buffer); 
 abxread(hwnd,buffer,sizeof(buffer));

 return(drawabx2(buffer,hdc,hfont,rect,flags,spa));
}



int drawabxeraseback(char * p,HDC hdc,RECT * rect,int flags)
{
// RECT             rc;
 int              itype;
 char             itemtext[1024];
 int              backcol=0;
 int              colcode;
 int              code;
 HBRUSH           brush;
 int              renderstate;
 int              command;
 int              negate;
 int              xshift;
 int              greyseen;
	char           * s;
	int              c;


 code=0;


	renderstate=1;

// cprintf("buffer %s",p);
 while(*p)
 {
  p=getitem(p,&itype,itemtext);

  switch(itype)
  {

    case 'k':
             if(renderstate) backcol=getint(itemtext,NULL);
//             cprintf("backcol=%x %s",backcol,itemtext);
             break;
  
    case 'F':
             colcode=(backcol & CCMASK);
             if(colcode!=CCNULL)
             {
              if(colcode==CCRGB)
              {
//               cprintf("brush fill");
               brush=CreateSolidBrush((backcol>>8) & 0xFFFFFF);
               FillRect(hdc,(LPRECT)rect,brush);
               DeleteObject(brush);
              }
              else
              if(colcode<CCSYSBASE)  // 1 to 17 wimp colour
              {
               if(cvdu.bpp<=8)
               {
                if(cvdu.palettesupport)
                {
                 physicalpaletteselect(hdc);
                 brush=CreateSolidBrush(PALETTEINDEX(cvdu.wimpcolnos[colcode-CCWIMPBASE]));
                }
                else
                {
                 brush=CreateSolidBrush(COLREFFROMPAL(systempalette[cvdu.wimpcolnos[colcode-CCWIMPBASE]]));
                }
               }
               else
               {
                brush=CreateSolidBrush((cvdu.vdupal.c[colcode-CCWIMPBASE].word>>8) & 0xFFFFFF);
               }

       //        cprintf("wimp fill");
               FillRect(hdc,(LPRECT)rect,brush);
               DeleteObject(brush);
              }
              else
              if(colcode<CCTRANSPARENT)  // 18 to 18+MAXSYSCOLOUR-1 windows system colours
              {
       //        cprintf("win fill");
               FillRect(hdc,(LPRECT)rect,(HBRUSH)GetSysColorBrush(winsyscolour[colcode-18]));
              }
              else                    // 255 transparent
              {

              }
  
              code=1;
             }
             break;


    case 'O':
             s=itemtext;
             command=negate=xshift=greyseen=0;

             while((c=*s++)!=0)
             {
              if(c=='!')
              {
               negate=1;
               continue;
              }

              if(c=='+' || c=='-')
              {
               command=c;
               continue;
              }

              if(c=='S') xshift=((flags & USDSELECTED)!=0);
              else
              if(c=='P') xshift=((flags & USDPUSHED)!=0);
              else
              if(c=='M') xshift=((flags & USDMOUSE)!=0);
              else
              if(c=='F') xshift=((flags & USDFOCUS)!=0);
              else
              if(c=='G')
              {
               xshift=((flags & USDGREYED)!=0);
               greyseen=1;
              }
              else
              if(c=='1') xshift=1;
              else
              if(c=='0') xshift=0;

              if(negate) xshift=!xshift;

              if(command=='-') renderstate=renderstate && xshift;
              else
              if(command=='+') renderstate=renderstate || xshift;
              else             renderstate=xshift;

              command=negate=0;
             }
             break;



  }
 }

 return(code);
}



int abxeraseback(HWND hwnd,HDC hdc)
{
 TCHAR            buffer[256]; 
 int              word;
 RECT             rect;

 GetClientRect(hwnd,&rect);
// SendMessage(hwnd,WM_GETTEXT,sizeof(buffer),(LPARAM)buffer); 

 word=GetWindowLong(hwnd,ABXFLAGS);
 abxread(hwnd,buffer,sizeof(buffer)/sizeof(TCHAR));

 return(drawabxeraseback(buffer,hdc,&rect,word));
}


